import org.apache.xmlrpc.webserver.*;
import org.apache.xmlrpc.server.*;
import java.net.*;
import java.util.*;
import bib.*;

public class Xj1Serv {
    public static String pathServ;
    public static int port;

    public String ping() {
        try {
            InetAddress host = InetAddress.getLocalHost();
            return "Java XML-RPC " + pathServ + " " + host.getHostName() + " ("
                    + host.getHostAddress() + ": " + port + "), " + new Date();
        } catch (Exception e) {
            return "ERROR";
        }
    }

    public String upcase(String s) {
        return s.toUpperCase();
    }

    public Integer add(Integer a, Integer b) {
        return new Integer(a + b);
    }

    public Xj1Serv() {
        ;
    }

    public Xj1Serv(String urlServ) throws Exception {
        Hashtable<String, String> url = Hurl.hurl(urlServ);
        port = Integer.parseInt(url.get("port"));
        pathServ = url.get("path");
        WebServer webServer = new WebServer(port);
        XmlRpcServer serviciu = webServer.getXmlRpcServer();
        XmlRpcServerConfigImpl config = new XmlRpcServerConfigImpl();
        serviciu.setConfig(config);
        PropertyHandlerMapping mapping = new PropertyHandlerMapping();
        mapping.addHandler(pathServ, Xj1Serv.class);
        serviciu.setHandlerMapping(mapping);
        System.out.println("Java XML-RPC service " + pathServ + " waiting at: "
                + urlServ);
        webServer.start();
    }

    public static void main(String[] args) throws Exception {
        if (args.length > 0)
            new Xj1Serv(args[0]);
        else
            new Xj1Serv("http://0.0.0.0:1002/Xj1");
    }
}
